=== AspectC++/tests/Attribute_basic/Makefile ===
ACFLAGS ?= --data_joinpoints --builtin_operators
CXXFLAGS ?= -std=c++17
include ../Makefile.generic
