=== AspectC++/tests/ExecAdviceNewDelete/Makefile ===
AC_PATTERN_REPLACEMENTS := | sed -e "s/new(.*)/new(<<<replaced>>>)/" | sed -e "s/new\[\](.*)/new[](<<<replaced>>>)/" | sed -e "s/void \*,.*)/void \*)/"
include ../Makefile.generic
