=== AspectC++/tests/PragmaAcxxAffect/Makefile ===
WEAVE_ERROR := 1
AC_PATTERN_REPLACEMENTS := | sed -e 's/.*\/tests\/PragmaAcxxAffect\///'
include ../Makefile.generic
