=== debian/changelog ===
aspectc++ (1:2.5-1) unstable; urgency=medium

  * New upstream version 2.5, Closes: #1120401, #1096333

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 29 Dec 2025 17:06:43 -0500
